package member

import (
	"fmt"

	"git.loafle.net/overflow/overflow_server_app/server"

	"git.loafle.net/overflow/overflow_server_app/backend"
	"github.com/valyala/fasthttp"
	"encoding/json"
)

type Member struct {
	Id          string `json:"id"`
	Email       string `json:"email"`
	Pw          string `json:"pw"`
	Name        string `json:"name"`
	CompanyName string `json:"companyName"`
	Phone       string `json:"phone"`
}

func SignUp(sctx *server.ServerContext, ctx *fasthttp.RequestCtx) {
	grpcPool := sctx.Value("grpc").(backend.Pool)
	c, err := grpcPool.Get()
	if nil != err {

	}
	defer c.Close()

	fmt.Fprintf(ctx, "avail: %d\n", grpcPool.Available())

	var webParams []interface{}
	webBytes := ctx.PostBody()
	err = json.Unmarshal(webBytes, &webParams)

	if err != nil {
		fmt.Fprintf(ctx, "Err!!!!: %s\n", err)
	}

	length := len(webParams)

	if length < 0 {
		fmt.Println("eeee")
	}

	jsonMap := webParams[0].(map[string]interface{})
	memberMap := jsonMap["member"].(map[string]interface{})

	m := &Member{}
	m.Email = memberMap["email"].(string)
	m.Name = memberMap["name"].(string)
	m.CompanyName = memberMap["companyName"].(string)
	m.Phone = memberMap["phone"].(string)
	m.Pw = memberMap["pw"].(string)

	mm,_ := json.Marshal(m)
	params := []string{string(mm), string(m.Pw)}

	r, err := c.Exec("MemberService", "signup", params)

	fmt.Fprintf(ctx, "Welcome!!!!: %s\n", r)
}
